docker-build-master:
  image: docker:latest
  stage: build
  services:
    - docker:dind

  before_script:
    # Create a tag using the commit and the job ID
    - export TAG=${CI_COMMIT_SHORT_SHA}-${CI_JOB_ID}

    # Login into the containers registry
    - docker login $CI_REGISTRY -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" 

  script:
    # Build and push the real image
    - cd app/ && docker build -t $CI_REGISTRY/${CI_PROJECT_PATH}:$TAG .
    - docker push $CI_REGISTRY/${CI_PROJECT_PATH}:$TAG

    # Retag and push the image to have a latest tag
    - docker tag $CI_REGISTRY/${CI_PROJECT_PATH}:$TAG $CI_REGISTRY/${CI_PROJECT_PATH}:latest
    - docker push $CI_REGISTRY/${CI_PROJECT_PATH}:latest
  only:
    - master
